﻿Imports Microsoft.Reporting.WinForms

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim rw = DtsBusiness.Merchandise.AddMerchandiseRow("Hammer")
        DtsBusiness.Seller.AddSellerRow(rw, "Junior")
        DtsBusiness.Seller.AddSellerRow(rw, "Senior")
        DtsBusiness.Seller.AddSellerRow(rw, "Detlef")
        rw = DtsBusiness.Merchandise.AddMerchandiseRow("Zange")
        DtsBusiness.Seller.AddSellerRow(rw, "Junior")
        DtsBusiness.Seller.AddSellerRow(rw, "Hagen")
        rw = DtsBusiness.Merchandise.AddMerchandiseRow("Schraube")
        DtsBusiness.Seller.AddSellerRow(rw, "Senior")
        DtsBusiness.Seller.AddSellerRow(rw, "Detlef")
        DtsBusiness.Seller.AddSellerRow(rw, "Susi")
        DtsBusiness.Seller.AddSellerRow(rw, "Thomas")
        DtsBusiness.Seller.AddSellerRow(rw, "Marion")
        '
        UpdateReport()
    End Sub

    Private Sub UpdateReport()
        With Me.ReportViewer1
            .LocalReport.DataSources.Clear()
            .LocalReport.DataSources.Add(New ReportDataSource("DataSet1", From articles In DtsBusiness.Merchandise
                                                                          Join vendors In DtsBusiness.Seller On articles.ID Equals vendors.MerchandiseID
                                                                          Select New ItemArticleAndVendor(articles.Article, vendors.Vendor)))
            .LocalReport.ReportEmbeddedResource = "JoinedReport.ArticleAndVendor.rdlc"
            .RefreshReport()
        End With
    End Sub

    Private Sub MerchandiseBindingSource_PositionChanged(sender As Object, e As EventArgs) Handles MerchandiseBindingSource.ListChanged, SellerBindingSource.ListChanged
        UpdateReport()
    End Sub

    Private Sub ReportViewer1_ReportRefresh(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles ReportViewer1.ReportRefresh
        UpdateReport()
    End Sub
End Class
